<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.12">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Built-in generic tools | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a> &gt; <span class="breadcrumb">Built-in generic tools</span>
   </div>
   <h2 id="built-in-generic-tools"><a class="anchor" href="#"></a>Built-in generic tools</h2>
   <div class="paragraph">
    <p>This page describes the built-in generic tools:</p>
   </div>
   <div class="ulist">
    <ul>
     <li><p><a href="#app-tool">app</a></p></li>
     <li><p><a href="#exec-tool">exec</a></p></li>
     <li><p><a href="#tooldef-tool">tooldef</a></p></li>
    </ul>
   </div>
   <div class="sect4">
    <h3 id="app-tool"><a class="anchor" href="#app-tool"></a>app tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int app(string? plugin, string classname, string... args,        string stdin = "-", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)
tool int app(string? plugin, string classname, list string args = [], string stdin = "-", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Executes an application framework application.</p>
    </div>
    <div class="paragraph">
     <p>The application is specified as a Java class that extends the <code>org.eclipse.escet.common.app.framework.Application</code> class. It should have a constructor that accepts one parameter, of type <code>org.eclipse.escet.common.app.framework.io.AppStreams</code>.</p>
    </div>
    <div class="paragraph">
     <p>The application is started within the current Java interpreter, in a new thread. If executed from an OSGi environment, such an application based on the Eclipse IDE, the class is loaded using the class loader of the given bundle (if provided), otherwise, it is loaded using the default class loader. In the latter case, the class should be in the class path.</p>
    </div>
    <div class="paragraph">
     <p>Note that this tool is only machine independent and platform independent, as long as the applications that are executed, are machine independent and platform independent as well.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>plugin</code>
      </dt>
      <dd>
       <p>The name of the plug-in (OSGi bundle) in which to resolve the application class. If the Java application is executed from an Eclipse-based IDE, then the class is loaded by the class loader of this bundle, otherwise it is resolved using the default class loader. May be <code>null</code> to always use the default class loader.</p>
      </dd>
      <dt class="hdlist1">
       <code>classname</code>
      </dt>
      <dd>
       <p>The absolute name of the Java class to execute as application.</p>
      </dd>
      <dt class="hdlist1">
       <code>args</code>
      </dt>
      <dd>
       <p>The command line arguments of the application to execute. Each argument string is parsed to zero or more actual arguments. It is possible to use a single string with all arguments (where the arguments themselves are separated by spaces), comma separated strings for each of the arguments (each string has one argument), or a mix of those.</p>
       <div class="paragraph">
        <p>In argument strings, individual arguments are separated by whitespace (spaces, tabs, new lines, etc). The whitespace itself is ignored, and only serves as separation. To include whitespace in an argument, the argument (or a part of it), may be quoted, by putting it between double quotes (<code>"</code>) or single quotes (<code>'</code>). Characters may be escaped by prefixing them with a backslash (<code>\</code>). This is particularly useful for single/double quotes, and escape characters, and can also be used to escape spaces. Escapes work the same inside of quoted parts as they do outside of quoted parts.</p>
       </div>
      </dd>
      <dt class="hdlist1">
       <code>stdin</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard input (stdin) stream and where the input comes from. Use <code>""</code> to not have a stdin stream, <code>"-"</code> to use the stdin stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file from which to read the standard input. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stdout</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard output (stdout) stream and where to write the standard output. Use <code>""</code> to not have a stdout stream, <code>"-"</code> to use the stdout stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard output. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stderr</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard error (stderr) stream and where to write the standard error output. Use <code>""</code> to not have a stderr stream, <code>"-"</code> to use the stderr stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard error output. May contain both <code>\</code> and <code>/</code> as file separators. Is ignored when the standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendOut</code>
      </dt>
      <dd>
       <p>Whether to append to the stdout file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored when standard output is not written to a file.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendErr</code>
      </dt>
      <dd>
       <p>Whether to append to the stderr file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored if standard error output is not written to a file. Is also ignored when standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>errToOut</code>
      </dt>
      <dd>
       <p>Whether to redirect the standard error stream to the standard output stream (<code>true</code>) or use separate streams (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>ignoreNonZeroExitCode</code>
      </dt>
      <dd>
       <p>Whether to ignore non-zero exit codes (<code>true</code>) or consider them as errors (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The application exit code. See the application framework documentation for a description of the exit codes.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the class loader can not be obtained.</p></li>
      <li><p>If the class can not be found or loaded.</p></li>
      <li><p>If the class is not an application framework application.</p></li>
      <li><p>If an appropriate constructor is not available.</p></li>
      <li><p>If an instance of the application class can not be constructed.</p></li>
      <li><p>If parsing of the command line arguments fails.</p></li>
      <li><p>If the application fails to execute due to its thread being interrupted.</p></li>
      <li><p>If the application exits with a non-zero exit code and non-zero exit codes are not ignored.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="exec-tool"><a class="anchor" href="#exec-tool"></a>exec tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int exec(string cmd, string... args,        string stdin = "", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)
tool int exec(string cmd, list string args = [], string stdin = "", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Executes a system command or external application as a sub process.</p>
    </div>
    <div class="paragraph">
     <p>This tool should be avoided if possible, as it is in general not guaranteed to be cross platform and machine independent. Commands and external applications may not be available on all systems, or may have different behavior on different systems.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>cmd</code>
      </dt>
      <dd>
       <p>The name of the command or the absolute or relative local file system path of the external application to execute, using platform specific new line characters.</p>
      </dd>
      <dt class="hdlist1">
       <code>args</code>
      </dt>
      <dd>
       <p>The command line arguments of the command or external application to execute. Each argument string is parsed to zero or more actual arguments. It is possible to use a single string with all arguments (where the arguments themselves are separated by spaces), comma separated strings for each of the arguments (each string has one argument), or a mix of those.</p>
       <div class="paragraph">
        <p>In argument strings, individual arguments are separated by whitespace (spaces, tabs, new lines, etc). The whitespace itself is ignored, and only serves as separation. To include whitespace in an argument, the argument (or a part of it), may be quoted, by putting it between double quotes (<code>"</code>) or single quotes (<code>'</code>). Characters may be escaped by prefixing them with a backslash (<code>\</code>). This is particularly useful for single/double quotes, and escape characters, and can also be used to escape spaces. Escapes work the same inside of quoted parts as they do outside of quoted parts.</p>
       </div>
      </dd>
      <dt class="hdlist1">
       <code>stdin</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard input (stdin) stream and where the input comes from. Use <code>""</code> to not have a stdin stream, <code>"-"</code> to use the stdin stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file from which to read the standard input. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stdout</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard output (stdout) stream and where to write the standard output. Use <code>""</code> to not have a stdout stream, <code>"-"</code> to use the stdout stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard output. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stderr</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard error (stderr) stream and where to write the standard error output. Use <code>""</code> to not have a stderr stream, <code>"-"</code> to use the stderr stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard error output. May contain both <code>\</code> and <code>/</code> as file separators. Is ignored when the standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendOut</code>
      </dt>
      <dd>
       <p>Whether to append to the stdout file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored when standard output is not written to a file.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendErr</code>
      </dt>
      <dd>
       <p>Whether to append to the stderr file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored if standard error output is not written to a file. Is also ignored when standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>errToOut</code>
      </dt>
      <dd>
       <p>Whether to redirect the standard error stream to the standard output stream (<code>true</code>) or use separate streams (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>ignoreNonZeroExitCode</code>
      </dt>
      <dd>
       <p>Whether to ignore non-zero exit codes (<code>true</code>) or consider them as errors (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The exit code resulting from the execution of the command or external application.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If parsing of the command line arguments fails.</p></li>
      <li><p>If ToolDef fails to execution the command or external application.</p></li>
      <li><p>If execution results in a non-zero exit code and non-zero exit codes are not ignored.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="tooldef-tool"><a class="anchor" href="#tooldef-tool"></a>tooldef tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int tooldef(string... args,        string stdin = "-", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)
tool int tooldef(list string args = [], string stdin = "-", string stdout = "-", string stderr = "-", bool appendOut = false, bool appendErr = false, bool errToOut = false, bool ignoreNonZeroExitCode = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Executes a ToolDef script. Waits for that script to finish its execution before continuing with the current script.</p>
    </div>
    <div class="paragraph">
     <p>The script is executed within the current Java interpreter, in a new thread, using a new ToolDef interpreter.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>args</code>
      </dt>
      <dd>
       <p>The command line arguments for the ToolDef interpreter, including the path to the script to execute. Each argument string is parsed to zero or more actual arguments. It is possible to use a single string with all arguments (where the arguments themselves are separated by spaces), comma separated strings for each of the arguments (each string has one argument), or a mix of those.</p>
       <div class="paragraph">
        <p>In argument strings, individual arguments are separated by whitespace (spaces, tabs, new lines, etc). The whitespace itself is ignored, and only serves as separation. To include whitespace in an argument, the argument (or a part of it), may be quoted, by putting it between double quotes (<code>"</code>) or single quotes (<code>'</code>). Characters may be escaped by prefixing them with a backslash (<code>\</code>). This is particularly useful for single/double quotes, and escape characters, and can also be used to escape spaces. Escapes work the same inside of quoted parts as they do outside of quoted parts.</p>
       </div>
      </dd>
      <dt class="hdlist1">
       <code>stdin</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard input (stdin) stream and where the input comes from. Use <code>""</code> to not have a stdin stream, <code>"-"</code> to use the stdin stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file from which to read the standard input. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stdout</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard output (stdout) stream and where to write the standard output. Use <code>""</code> to not have a stdout stream, <code>"-"</code> to use the stdout stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard output. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>stderr</code>
      </dt>
      <dd>
       <p>Specify whether to have a standard error (stderr) stream and where to write the standard error output. Use <code>""</code> to not have a stderr stream, <code>"-"</code> to use the stderr stream of the ToolDef interpreter, or otherwise an absolute or relative local file system path of the file to which to write the standard error output. May contain both <code>\</code> and <code>/</code> as file separators. Is ignored when the standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendOut</code>
      </dt>
      <dd>
       <p>Whether to append to the stdout file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored when standard output is not written to a file.</p>
      </dd>
      <dt class="hdlist1">
       <code>appendErr</code>
      </dt>
      <dd>
       <p>Whether to append to the stderr file (<code>true</code>) or overwrite it (<code>false</code>). Is ignored if standard error output is not written to a file. Is also ignored when standard error stream is redirected to the standard output stream.</p>
      </dd>
      <dt class="hdlist1">
       <code>errToOut</code>
      </dt>
      <dd>
       <p>Whether to redirect the standard error stream to the standard output stream (<code>true</code>) or use separate streams (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>ignoreNonZeroExitCode</code>
      </dt>
      <dd>
       <p>Whether to ignore non-zero exit codes (<code>true</code>) or consider them as errors (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The ToolDef interpreter exit code, i.e. the exit code of the script.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If parsing of the command line arguments fails.</p></li>
      <li><p>If the application fails to execute due to its thread being interrupted.</p></li>
      <li><p>If execution results in a non-zero exit code and non-zero exit codes are not ignored.</p></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v4.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>